//B.Vandeportaele 2022
//parti d'un programme d'exemple:
//https://riptutorial.com/qt/example/29874/tcp-server


#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QDebug>
#include <QHostAddress>
#include <QAbstractSocket>

#include <QtWidgets>
#include <QtNetwork>


#include<iostream>
/*
 * ../tcp_server/mainwindow.cpp:33:31: warning: range-based 'for' loops only available with -std=c++11 or -std=gnu++11
 for (QTcpSocket* socket : _sockets) {
If you are using Qt5, add CONFIG += c++11 to your .pro file, that works on all systems.

*/

#include <math.h>


void Receiver::onNewConnection()
{
    QTcpSocket *clientSocket = _server.nextPendingConnection();
    connect(clientSocket, SIGNAL(readyRead()), this, SLOT(onReadyRead()));
    connect(clientSocket, SIGNAL(stateChanged(QAbstractSocket::SocketState)), this, SLOT(onSocketStateChanged(QAbstractSocket::SocketState)));

    _sockets.push_back(clientSocket);
    for (QTcpSocket* socket : _sockets) {

        //std::cout<< QByteArray::fromStdString(clientSocket->peerAddress().toString().toStdString() .c_str());
        std::cout<< clientSocket->peerAddress().toString().toStdString()<< endl;

        std::cout<<      " connected to server !"<< endl;
        //        socket->write(QByteArray::fromStdString(clientSocket->peerAddress().toString().toStdString() + " connected to server !\n"));
        //socket->write(QByteArray::fromStdString("salut"));

    }
}

//TODO, il faudra gérer la libération de la connexion

void Receiver::onSocketStateChanged(QAbstractSocket::SocketState socketState)
{
    if (socketState == QAbstractSocket::UnconnectedState)
    {
        QTcpSocket* sender = static_cast<QTcpSocket*>(QObject::sender());
        _sockets.removeOne(sender);
    }
}

void Receiver::onReadyRead()
{
    //traitement des requetes recues
    QTcpSocket* sender = static_cast<QTcpSocket*>(QObject::sender());
    QByteArray datas = sender->readAll();
    std::cout<<" recu:" << datas.toStdString().c_str() << endl;
    //renvoie une réponse à l'émeteur de la requete
    for (QTcpSocket* socket : _sockets) {
        if (socket == sender){
            unsigned int nbr;
            std::string st=datas.toStdString();
            //std::string reponse;
            char chaine[100];
            switch (st[0]){
            case 'g':
                nbr=getInputs();
                break;
            case 's':
                sscanf(datas.toStdString().c_str(),"s %d\n",&nbr);
                setOuputs(nbr);
                break;
            case 'n':
                nameLabel->setText(QString("Nom:")+QString(datas.toStdString().c_str()+2).replace("\n"," ")); //retire les retours à la ligne pour éviter que le widget soit trop haut
                break;
            case 'm':
                msgLabel->setText(QString("Msg:")+QString(datas.toStdString().c_str()+2).replace("\n"," "));  //retire les retours à la ligne pour éviter que le widget soit trop haut
                break;
            }
            sprintf(chaine, "%03d\n",nbr);
            socket->write(chaine);
        }
    }
}


unsigned char Receiver::getInputs(){
    unsigned char val=0;
    for (int i=0;i<8;i++){
        if (sw_inputs[i]->checkState()==Qt::Checked)
            val|=(1<<i);
    }
    QString hexvalue = QString("0x%1").arg(val, 2, 16, QLatin1Char( '0' )); // 2 digits en base 16 complété avec des 0
    inputLabel->setText(hexvalue);
    return val;
}

void Receiver::setOuputs(unsigned char val ){

    for (int i=0;i<8;i++){
        //sw_outputs[i]->setCheckable(true);
        sw_outputs[i]->setChecked(((val>>i)&1)!=0);
        //        sw_outputs[i]->setCheckable(false);
    }
    simulator->moteur=(val>>0)&1;
    simulator->switch1=(val>>1)&1;
    simulator->switch2=(val>>2)&1;
    simulator->stoppeurRetracte=(val>>3)&1;

    /*
 *       //sw_outputs[i]->repaint();
        //sw_outputs[i]->update();
    sw_outputs[2]->setChecked(true);
    sw_outputs[3]->setChecked(false);
    sw_outputs[4]->setCheckState(Qt::Checked);
    sw_outputs[5]->setCheckState(Qt::PartiallyChecked);
    /*for (int i=0;i<8;i++){
        if (((val>>i)&1)!=0)
            sw_outputs[i]->setCheckState(Qt::PartiallyChecked);
            //sw_outputs[i]->setCheckState(Qt::Checked);
        else
            sw_outputs[i]->setCheckState(Qt::Unchecked);
    }*/

    QString hexvalue = QString("0x%1").arg(val, 2, 16, QLatin1Char( '0' )); // 2 digits en base 16 complété avec des 0
    outputLabel->setText(hexvalue);
    //outputLabel->update();
    //this->update();
    //    this->repaint();
    //this->parentWidget()->repaint();
    //this->parentWidget()->parentWidget()->repaint();

}


Receiver::Receiver(QWidget *parent)
    : QDialog(parent)
{
    //statusLabel = new QLabel(tr("En attente de datagrammes UDP depuis le PIC32"));

    inputLabel = new QLabel(tr("0x--"));
    outputLabel = new QLabel(tr("0x--"));
    nameLabel = new QLabel(tr("Nom:"));
    msgLabel = new QLabel(tr("Msg:"));

    quitButton = new QPushButton(tr("&Quit"));
    connect(quitButton, SIGNAL(clicked()), this, SLOT(close()));

    QHBoxLayout *buttonLayout = new QHBoxLayout;
    buttonLayout->addStretch(1);
    buttonLayout->addWidget(quitButton);
    buttonLayout->addStretch(1);
    buttonLayout->addWidget(nameLabel);
    buttonLayout->addStretch(1);
    buttonLayout->addWidget(msgLabel);
    buttonLayout->addStretch(1);

    QHBoxLayout *button1Layout = new QHBoxLayout;
    button1Layout->addStretch(1);
    QHBoxLayout *button2Layout = new QHBoxLayout;
    button2Layout->addStretch(1);
    for (int i=7;i>=0;i--){
        sw_inputs[i] = new QCheckBox("in"+ QString::number(i), this);
        button1Layout->addWidget(sw_inputs[i]);
        button1Layout->addStretch(1);
        sw_outputs[i] = new QCheckBox("ou"+ QString::number(i), this);
        //sw_outputs[i]->setCheckable(false);
        //sw_outputs[i]->setCheckState(Qt::PartiallyChecked); //avant de recevoir une commande, la sortie est non initialisée
        button2Layout->addWidget(sw_outputs[i]);
        button2Layout->addStretch(1);
    }
    button1Layout->addWidget(inputLabel);
    button1Layout->addStretch(1);
    button2Layout->addWidget(outputLabel);
    button2Layout->addStretch(1);

    QVBoxLayout *mainLayout = new QVBoxLayout;
    mainLayout->addLayout(button1Layout);
    mainLayout->addLayout(button2Layout);
    //mainLayout->addWidget(statusLabel);
    mainLayout->addLayout(buttonLayout);


    //Gestion d'images inspirée de https://doc.qt.io/qt-5/qtwidgets-widgets-imageviewer-example.html
    QString fileName="station_composite.png";

    QImageReader reader(fileName);
    reader.setAutoTransform(true);
    simulatorImageFond=new QImage(reader.read());
    if (simulatorImageFond->isNull()) {
        QMessageBox::information(this, QGuiApplication::applicationDisplayName(),
                                 tr("Cannot load %1: %2")
                                 .arg(QDir::toNativeSeparators(fileName), reader.errorString()));
        exit(-1);
    }
    imageLabel = new QLabel(tr(""));
    imageLabel->setPixmap(QPixmap::fromImage(*simulatorImageFond));

    QHBoxLayout *imageEtbutton3Layout = new QHBoxLayout;
    imageEtbutton3Layout->addWidget(imageLabel);


    vide2Button = new QPushButton(tr("Vide &2"));
    vide1Button = new QPushButton(tr("Vide &1"));
    vide0Button = new QPushButton(tr("Vide &0"));
    ajouteNoireButton = new QPushButton(tr("Ajoute &Noire"));
    ajouteMetalButton = new QPushButton(tr("Ajoute &Metal"));
    ajouteRougeButton = new QPushButton(tr("Ajoute &Rouge"));

    connect(vide2Button, SIGNAL(clicked()), this, SLOT(vide2()));
    connect(vide1Button, SIGNAL(clicked()), this, SLOT(vide1()));
    connect(vide0Button, SIGNAL(clicked()), this, SLOT(vide0()));
    connect(ajouteNoireButton, SIGNAL(clicked()), this, SLOT(ajouteNoire()));
    connect(ajouteMetalButton, SIGNAL(clicked()), this, SLOT(ajouteMetal()));
    connect(ajouteRougeButton, SIGNAL(clicked()), this, SLOT(ajouteRouge()));



    QVBoxLayout *button3Layout = new QVBoxLayout;
    button3Layout->addStretch(1);
    button3Layout->addWidget(vide2Button);
    button3Layout->addStretch(1);
    button3Layout->addWidget(vide1Button);
    button3Layout->addStretch(1);
    button3Layout->addWidget(vide0Button);
    button3Layout->addStretch(1);
    button3Layout->addWidget(ajouteNoireButton);
    button3Layout->addStretch(1);
    button3Layout->addWidget(ajouteMetalButton);
    button3Layout->addStretch(1);
    button3Layout->addWidget(ajouteRougeButton);
    button3Layout->addStretch(300);

    imageEtbutton3Layout->addLayout(button3Layout);
    mainLayout->addLayout(imageEtbutton3Layout);

    setLayout(mainLayout);

    setWindowTitle(tr("appli serveur TCP CESI B.Vandeportaele 2022"));
    _server.listen(QHostAddress::Any, 4242);
    connect(&_server, SIGNAL(newConnection()), this, SLOT(onNewConnection()));
    this->setGeometry(10,10,1400,1000);    //pour image: 1242x896



    simulator =new(Simulator);

    //simulator->ajoutePiece(1);

    Timer=new QTimer(this);
    Timer->setInterval(10);
    connect(Timer, SIGNAL(timeout()), this, SLOT(on_timer_Event()));
    Timer->start();


}

//diamètre des disques 480à540=61pixels

void Receiver::drawDisc(QImage * img,uint16_t xc, uint16_t yc,uint16_t radius, unsigned char r,unsigned char g,unsigned char b){
    int16_t cptl=radius;
    uint32_t rgb=(r<<16) | (g<<8) | (b<<0);
    for( int i = yc-radius; i <= yc+radius; i++ ) {//differentes lignes
        float theta=asin(cptl/(float)(radius+1));
        uint16_t radiusl=radius*cos(theta);
        cptl--;
        uint16_t x1=xc-radiusl;
        uint16_t x2=xc+radiusl;
        for( int j = x1; j <= x2; j++ )
            img->setPixel(j,i,rgb);
    }
}

void Receiver::on_timer_Event()
{
    QImage simulatorImage=simulatorImageFond->copy();
    //sur l'image composite, switch2 est ouvert, switch1 est fermé
    uint16_t switch_x1=230;
    uint16_t switch_y1=151;
    uint16_t switch_x2=363;
    uint16_t switch_y2=264;
    //offset x entre les 2 switchs: 355->495=140
    uint16_t offsetSwichts=140;
    if (simulator->switch2==1) //si switch2 fermé, il faut remplacer l'image
        for( int i = 0; i <= switch_y2-switch_y1; i++ )
            for(int j = 0; j <= switch_x2-switch_x1; j++)
                simulatorImage.setPixel(j+switch_x1,i+switch_y1,simulatorImageFond->pixel(j+switch_x1+offsetSwichts,i+switch_y1));
    if (simulator->switch1==0) //si switch1 ouvert, il faut remplacer l'image
        for( int i = 0; i <= switch_y2-switch_y1; i++ )
            for(int j = 0; j <= switch_x2-switch_x1; j++)
                simulatorImage.setPixel(j+switch_x1+offsetSwichts,i+switch_y1,simulatorImageFond->pixel(j+switch_x1,i+switch_y1));

    uint16_t stoppeur_x1=703;
    uint16_t stoppeur_y1=200;
    uint16_t stoppeur_x2=714;
    uint16_t stoppeur_y2=225;
    uint16_t offsetStoppeur=35;
    if (simulator->stoppeurRetracte==1) //si stoppeur est rétracté, il faut remplacer l'image
        for( int i = 0; i <= stoppeur_y2-stoppeur_y1; i++ )
            for(int j = 0; j <= stoppeur_x2-stoppeur_x1; j++)
                simulatorImage.setPixel(j+stoppeur_x1,i+stoppeur_y1,simulatorImageFond->pixel(j+stoppeur_x1,i+stoppeur_y1+offsetStoppeur));

    //animation pour tests
    /*
    static int a=0;
    a=(a+1)%200;
    if (a==0)        simulator->switch2=(simulator->switch2+1)%2;
    if (a==100)      simulator->switch1=(simulator->switch1+1)%2;
    if (a==50)       simulator->stoppeurRetracte=(simulator->stoppeurRetracte+1)%2;
    if (a==30)       simulator->ajoutePiece(1);
*/
    //trace les troncons pour debug
    /*
    unsigned char r=255;    unsigned char g=0;    unsigned char b=0;    uint32_t rgb=(r<<16) | (g<<8) | (b<<0);
    for (uint16_t n=0;n<simulator->nbTroncons;n++){
        for (uint16_t np=0;np<simulator->tabTroncons[n].nbPoints;np++){
            simulatorImage.setPixel(simulator->tabTroncons[n].points[np].x,simulator->tabTroncons[n].points[np].y,rgb);
        }
    }*/

    simulator->anime();
    //les capteurs sont actifs à 0, et je coche si capteur inactif
    sw_inputs[0]->setChecked(simulator->piecepresente==0);
    sw_inputs[1]->setChecked(simulator->piecemetal==0);
    sw_inputs[2]->setChecked(simulator->piecenonnoire==0);
    sw_inputs[3]->setChecked(simulator->glissierepleine==0);


    //vide,rouge,metal,noir
    uint32_t tabColor[4]={0xffffff,0xff0000,0xA0A0A0,0x000000};
    for (uint16_t n=0;n<simulator->nbTroncons;n++){
        for (uint16_t np=0;np<simulator->tabTroncons[n].nbPoints;np++){
            if (simulator->tabTroncons[n].points[np].occupation!=0){
                uint16_t x1=simulator->tabTroncons[n].points[np].x;
                uint16_t y1=simulator->tabTroncons[n].points[np].y;
                uint32_t col=tabColor[simulator->tabTroncons[n].points[np].occupation];
                drawDisc(&simulatorImage,x1,y1,30,(col>>16)&0xff,(col>>8)&0xff,(col>>0)&0xff);
            }
        }
    }
    imageLabel->setPixmap(QPixmap::fromImage(simulatorImage));
}

void Receiver::vide2(){
    simulator->retirePiece(2);
}

void Receiver::vide1(){
    simulator->retirePiece(1);
}

void Receiver::vide0(){
    simulator->retirePiece(0);
}

void Receiver::ajouteNoire(){
    simulator->ajoutePiece(3);
}

void Receiver::ajouteMetal(){
    simulator->ajoutePiece(2);
}

void Receiver::ajouteRouge(){
    simulator->ajoutePiece(1);
}
