//B.Vandeportaele 2022

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTcpServer>
#include <QTcpSocket>
#include <QDialog>
#include <QCheckBox>
#include <QSlider>


QT_BEGIN_NAMESPACE
class QLabel;
class QPushButton;
class QUdpSocket;
QT_END_NAMESPACE

#include "simulator.h"

class Receiver : public QDialog
{
    Q_OBJECT
public:
    Receiver(QWidget *parent = 0);
private:
    QLabel *statusLabel;
    QPushButton *quitButton;
    QCheckBox * sw_inputs[8];
    QCheckBox * sw_outputs[8];
    QTcpServer  _server;
    QList<QTcpSocket*>  _sockets;

    unsigned char getInputs();
    void setOuputs(unsigned char val);

    QLabel *inputLabel;
    QLabel *outputLabel;
    QLabel *nameLabel;
    QLabel *msgLabel;

    QImage *simulatorImageFond;
    QLabel *imageLabel;

    QPushButton *vide2Button;
    QPushButton *vide1Button;
    QPushButton *vide0Button;
    QPushButton *ajouteNoireButton;
    QPushButton *ajouteMetalButton;
    QPushButton *ajouteRougeButton;


    QTimer * Timer;
    Simulator *simulator;

    void drawDisc(QImage * img,uint16_t xc, uint16_t yc,uint16_t radius, unsigned char r,unsigned char g,unsigned char b);

private slots:
    void on_timer_Event();


public slots:
    void onNewConnection();
    void onSocketStateChanged(QAbstractSocket::SocketState socketState);
    void onReadyRead();

    void vide2();
    void vide1();
    void vide0();
    void ajouteNoire();
    void ajouteMetal();
    void ajouteRouge();
};





#endif // MAINWINDOW_H
